"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
var _exportNames = {
    compiler: true,
    utils: true
};
exports.utils = exports.compiler = void 0;
var _matrixCompile = _interopRequireDefault(require("./matrix-compile/matrixCompile"));
var _matrixServer = _interopRequireDefault(require("./matrix-server/matrixServer"));
var _getExtMetroConfig = require("./matrix-config/getExtMetroConfig");
var _generateBuildResult = require("./lib/generateBuildResult");
var _getRegisterComponents = require("./lib/getRegisterComponents");
var _configTypes = _interopRequireWildcard(require("./matrix-config/configTypes"));
Object.keys(_configTypes).forEach(function(key) {
    if (key === "default" || key === "__esModule") return;
    if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
    if (key in exports && exports[key] === _configTypes[key]) return;
    Object.defineProperty(exports, key, {
        enumerable: true,
        get: function() {
            return _configTypes[key];
        }
    });
});
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _getRequireWildcardCache() {
    if (typeof WeakMap !== "function") return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function() {
        return cache;
    };
    return cache;
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
var compiler = {
    compile: _matrixCompile.default,
    devServer: _matrixServer.default,
    getExtMetroConfig: _getExtMetroConfig.getExtMetroConfig
};
exports.compiler = compiler;
var utils = {
    generateDevBuildResult: _generateBuildResult.generateDevBuildResult,
    generateProdBuildResult: _generateBuildResult.generateProdBuildResult,
    getRegisterComponents: _getRegisterComponents.getRegisterComponents,
    getActualComponents: _getRegisterComponents.getActualComponents
};
exports.utils = utils;
