"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.generateProdUrl = generateProdUrl;
exports.generateProdBuildResult = generateProdBuildResult;
exports.generateDevBuildResult = generateDevBuildResult;
exports.generateBuildResult = generateBuildResult;
var _ramda = _interopRequireDefault(require("ramda"));
function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _iterableToArrayLimit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _objectSpreadProps(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function generateProdUrl(param) {
    var extType = param.extType, extUuid = param.extUuid, registerComponent = param.registerComponent, SDKVersion = param.SDKVersion, md5 = param.md5, rnbaseurl = param.rnbaseurl, rnbasemd5 = param.rnbasemd5, RNVersion = param.RNVersion;
    var values = {
        rnext: 1,
        hyaction: "newrn",
        // 1. 不要轻易改变这个 rnmodule 格式, 可能会影响到后端的统计
        // 2. 这个名称不要包含非 ascii 值
        rnmodule: "".concat(extUuid, "-").concat(extType, "-").concat(extUuid),
        rnentry: registerComponent,
        sdkversion: SDKVersion,
        rnmd5: md5,
        framework: RNVersion || process.env.HYEXT_RN_VER || "0"
    };
    if (rnbaseurl && rnbasemd5) {
        values = _objectSpreadProps(_objectSpread({}, values), {
            rnbaseurl: rnbaseurl,
            rnbasemd5: rnbasemd5
        });
    }
    return Object.entries(values).map(function(param) {
        var _param = _slicedToArray(param, 2), k = _param[0], v = _param[1];
        return "".concat(k, "=").concat(encodeURIComponent(v));
    }).join("&");
}
var generateDevUrl = function(component, platform) {
    return "rnentry=".concat(component, "&platform=").concat(platform, "&rnext=1&hyaction=newrn");
};
function generateProdBuildResult(param) {
    var builderName = param.builderName, extInfo = param.extInfo, buildResultConfig = param.buildResultConfig;
    var config = buildResultConfig.map(function(cfg) {
        return _objectSpreadProps(_objectSpread({}, cfg), {
            registerComponents: cfg.registerComponents.map(function(param) {
                var name = param.name, queryString = param.queryString;
                return {
                    name: name,
                    queryString: queryString || generateProdUrl(_objectSpreadProps(_objectSpread({}, extInfo), {
                        extType: cfg.extType,
                        registerComponent: name,
                        SDKVersion: cfg.SDKVersion,
                        md5: cfg.bundleMd5,
                        rnbaseurl: cfg.baseUrl,
                        rnbasemd5: cfg.baseMd5
                    }))
                };
            })
        });
    });
    return generateBuildResult({
        builderName: builderName,
        devServerOrigin: "",
        buildResultConfig: config
    });
}
function generateDevBuildResult(param) {
    var builderName = param.builderName, devServerOrigin = param.devServerOrigin, buildResultConfig = param.buildResultConfig;
    var config = buildResultConfig.map(function(cfg) {
        return _objectSpreadProps(_objectSpread({}, cfg), {
            registerComponents: cfg.registerComponents.map(function(param) {
                var name = param.name, queryString = param.queryString;
                return {
                    name: name,
                    queryString: queryString || generateDevUrl(name, cfg.platform)
                };
            })
        });
    });
    return generateBuildResult({
        builderName: builderName,
        devServerOrigin: devServerOrigin,
        buildResultConfig: config
    });
}
function generateBuildResult(param) {
    var builderName = param.builderName, devServerOrigin = param.devServerOrigin, buildResultConfig = param.buildResultConfig;
    var buildResult = {};
    buildResultConfig.forEach(function(param) {
        var extType = param.extType, bundleRelativePath = param.bundleRelativePath, registerComponents = param.registerComponents, platform = param.platform, SDKVersion = param.SDKVersion, _bundleType = param.bundleType, bundleType = _bundleType === void 0 ? "RN_BUNDLE" : _bundleType;
        var result = _defineProperty({}, extType, {
            type: bundleType,
            builder: builderName,
            content: {
                sdkVersion: SDKVersion,
                baseURI: devServerOrigin,
                rnBundle: _defineProperty({}, platform, {
                    path: bundleRelativePath,
                    entries: registerComponents.map(function(param) {
                        var name = param.name, queryString = param.queryString;
                        return {
                            name: name,
                            url: queryString
                        };
                    })
                })
            }
        });
        buildResult = _ramda.default.mergeDeepLeft(result, buildResult);
    });
    return buildResult;
}
