"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getActualComponents = getActualComponents;
exports.getRegisterComponents = getRegisterComponents;
var _ramda = _interopRequireDefault(require("ramda"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function getActualComponents(entryFileContent) {
    var reg = /^\s*(AppRegistry.registerComponent|registerApp)\(['"](\S+)['"]/gm;
    var components = [];
    var match;
    while(match = reg.exec(entryFileContent)){
        components.push(match[2]);
    }
    return components;
}
function getRegisterComponents(param) {
    var entryFileContent = param.entryFileContent, _configComponents = param.configComponents, configComponents = _configComponents === void 0 ? [] : _configComponents;
    var actualComponents = getActualComponents(entryFileContent);
    if (actualComponents.length === 1) {
        return actualComponents;
    }
    if (actualComponents.length <= 0) {
        return [];
    }
    // case3: 有多个, 但是在配置文件中没有指定需要哪一个
    if (!configComponents || configComponents.length <= 0) {
        // message: `入口文件 ${entry} 注册了多个组件: ${actualComponents.join(';')}\n将使用最后注册的组件: ${R.last(actualComponents)}`,
        return [
            _ramda.default.last(actualComponents)
        ];
    }
    // 以下代码, 均在存在 configComponents, 多个 actualComponents 情况下运行
    // case4: 有多个, 在配置文件中声明了使用的入口组件名称
    if (actualComponents.includes(_ramda.default.head(configComponents))) {
        return [
            _ramda.default.head(configComponents)
        ];
    }
    // case5: 有多个, 在配置文件中声明了使用的入口名称, 但是实际不存在
    if (!actualComponents.includes(_ramda.default.head(configComponents))) {
        return [
            _ramda.default.last(actualComponents)
        ];
    }
    throw new Error("cant find any registerComponent");
}
