"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = exports.dbg = void 0;
var _chalk = _interopRequireDefault(require("chalk"));
var _debug = _interopRequireDefault(require("debug"));
var _constants = require("../constants");
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
var dbg = (0, _debug).default(_constants.APP_NAME);
exports.dbg = dbg;
var SEPARATOR = ", ";
var verbose = false;
var disabled = false;
var formatMessages = function(messages) {
    return _chalk.default.reset(messages.join(SEPARATOR));
};
var success = function() {
    for(var _len = arguments.length, messages = new Array(_len), _key = 0; _key < _len; _key++){
        messages[_key] = arguments[_key];
    }
    if (!disabled) {
        console.log("".concat(_chalk.default.green.bold("success"), " ").concat(formatMessages(messages)));
    }
};
var info = function() {
    for(var _len = arguments.length, messages = new Array(_len), _key = 0; _key < _len; _key++){
        messages[_key] = arguments[_key];
    }
    if (!disabled) {
        console.log("".concat(_chalk.default.cyan.bold("info"), " ").concat(formatMessages(messages)));
    }
};
var warn = function() {
    for(var _len = arguments.length, messages = new Array(_len), _key = 0; _key < _len; _key++){
        messages[_key] = arguments[_key];
    }
    if (!disabled) {
        console.warn("".concat(_chalk.default.yellow.bold("warn"), " ").concat(formatMessages(messages)));
    }
};
var error = function() {
    for(var _len = arguments.length, messages = new Array(_len), _key = 0; _key < _len; _key++){
        messages[_key] = arguments[_key];
    }
    if (!disabled) {
        console.error("".concat(_chalk.default.red.bold("error"), " ").concat(formatMessages(messages)));
    }
};
var debug = function() {
    for(var _len = arguments.length, messages = new Array(_len), _key = 0; _key < _len; _key++){
        messages[_key] = arguments[_key];
    }
    if (verbose && !disabled) {
        console.log("".concat(_chalk.default.gray.bold("debug"), " ").concat(formatMessages(messages)));
    }
};
var log = function() {
    for(var _len = arguments.length, messages = new Array(_len), _key = 0; _key < _len; _key++){
        messages[_key] = arguments[_key];
    }
    if (!disabled) {
        console.log("".concat(formatMessages(messages)));
    }
};
var setVerbose = function(level) {
    verbose = level;
};
var isVerbose = function() {
    return verbose;
};
var disable = function() {
    disabled = true;
};
var enable = function() {
    disabled = false;
};
var _default = {
    success: success,
    info: info,
    warn: warn,
    error: error,
    debug: debug,
    log: log,
    setVerbose: setVerbose,
    isVerbose: isVerbose,
    disable: disable,
    enable: enable
};
exports.default = _default;
