"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = _default;
var _fsExtra = _interopRequireDefault(require("fs-extra"));
var _crypto = _interopRequireDefault(require("crypto"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _default(absPath) {
    return new Promise(function(resolve, reject) {
        var rs = _fsExtra.default.createReadStream(absPath);
        var hash = _crypto.default.createHash("md5");
        rs.on("data", hash.update.bind(hash));
        rs.on("end", function() {
            resolve(hash.digest("hex"));
        });
        rs.on("error", function(err) {
            reject(err);
        });
    });
}
