"use strict";
var _validateAnimatedValue = require("./validateAnimatedValue");
describe("getVersionFromStr", function() {
    it("with empty lines", function() {
        var str = "\n/Users/simon/Developer/huya/hyext/just-dance/node_modules/@hyext/hy-ui:@hyext/hy-ui@1.3.26\n/Users/simon/Developer/huya/hyext/just-dance/node_modules/@hyext/hy-ui:@hyext/hy-ui@1.1.26\n\n";
        expect((0, _validateAnimatedValue).getVersionFromStr(str)).toEqual([
            "1.3.26",
            "1.1.26"
        ]);
    });
});
describe("validateVersions", function() {
    it("empty list", function() {
        expect((0, _validateAnimatedValue).validateVersionList([])).toBe(true);
    });
    it("all greater or equal than base", function() {
        expect((0, _validateAnimatedValue).validateVersionList([
            "1.2.3",
            "1.2.4",
            "1.2.4-beta.0"
        ], "1.2.3")).toBe(true);
    });
    it("some smaller than base", function() {
        expect((0, _validateAnimatedValue).validateVersionList([
            "1.1.0",
            "1.2.3-beta.0",
            "1.4.0"
        ], "1.2.3")).toBe(false);
    });
});
