"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.batchCompile = batchCompile;
var _regeneratorRuntime = _interopRequireDefault(require("regenerator-runtime"));
var _dependencyGraph = _interopRequireDefault(require("metro/src/node-haste/DependencyGraph"));
var _transformer = _interopRequireDefault(require("metro/src/DeltaBundler/Transformer"));
var _deltaCalculator = _interopRequireDefault(require("metro/src/DeltaBundler/DeltaCalculator"));
var _path = _interopRequireDefault(require("path"));
var _saveAssets = _interopRequireDefault(require("@react-native-community/cli-plugin-metro/build/commands/bundle/saveAssets"));
var _saveOutput = _interopRequireDefault(require("./saveOutput"));
var _calcTransformerOptions = require("./calcTransformerOptions");
var _getType = require("./getType");
var _getAssets = require("./getAssets");
var _getPrepended = require("./getPrepended");
var _getExtMetroConfig = require("../matrix-config/getExtMetroConfig");
function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _iterableToArrayLimit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _objectSpreadProps(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function batchCompile(_) {
    return _batchCompile.apply(this, arguments);
}
function _batchCompile() {
    _batchCompile = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee(param) {
        var config, bundleConfigs, ref, serializerOptions, dependencyGraph, transformer, absoluteEntryFiles, getPlatformGraph, graphList, promiseFactories, outputList, assets;
        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    config = param.config, bundleConfigs = param.bundleConfigs;
                    ;
                    serializerOptions = {
                        excludeSource: false,
                        inlineSourceMap: false,
                        modulesOnly: false,
                        runModule: true,
                        sourceMapUrl: undefined,
                        sourceUrl: undefined
                    };
                    _ctx.next = 5;
                    return _dependencyGraph.default.load(config, {
                        watch: false
                    });
                case 5:
                    dependencyGraph = _ctx.sent;
                    transformer = new _transformer.default(config, dependencyGraph.getSha1.bind(dependencyGraph));
                    absoluteEntryFiles = bundleConfigs.map(function(xs) {
                        return xs.entryAbsPath;
                    });
                    getPlatformGraph = function() {
                        var _ref = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee(platform) {
                            var ref, ref1, transformOptions, calculatedOptions, deltaCalculator, graph, _getAssets1, ref2, prepend, assets;
                            return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
                                while(1)switch(_ctx.prev = _ctx.next){
                                    case 0:
                                        ;
                                        transformOptions = {
                                            customTransformOptions: Object.create(null),
                                            dev: false,
                                            hot: false,
                                            minify: true,
                                            platform: platform,
                                            runtimeBytecodeVersion: undefined,
                                            type: "module",
                                            unstable_transformProfile: "default"
                                        };
                                        _ctx.next = 4;
                                        return (0, _calcTransformerOptions).calcTransformerOptions(config, transformOptions);
                                    case 4:
                                        calculatedOptions = _ctx.sent;
                                        deltaCalculator = new _deltaCalculator.default(absoluteEntryFiles, dependencyGraph, {
                                            resolve: function(from, to) {
                                                return dependencyGraph.resolveDependency(from, to, platform);
                                            },
                                            transform: function(filepath) {
                                                if (!config.serializer.processModuleFilter({
                                                    path: filepath
                                                })) {
                                                    return Promise.resolve(_getExtMetroConfig.skipModulePlaceHolder);
                                                }
                                                return transformer.transformFile(filepath, _objectSpreadProps(_objectSpread({}, calculatedOptions), {
                                                    type: (0, _getType).getType(config, calculatedOptions, filepath),
                                                    inlineRequires: false
                                                }));
                                            },
                                            transformOptions: transformOptions,
                                            onProgress: null,
                                            experimentalImportBundleSupport: false,
                                            shallow: false
                                        });
                                        _ctx.next = 8;
                                        return deltaCalculator.getDelta({
                                            reset: true,
                                            shallow: false
                                        });
                                    case 8:
                                        graph = deltaCalculator.getGraph();
                                        (ref = config.serializer) === null || ref === void 0 ? void 0 : (ref1 = ref.experimentalSerializerHook) === null || ref1 === void 0 ? void 0 : ref1.call(ref, graph, {
                                            added: graph.dependencies,
                                            modified: new Map(),
                                            deleted: new Set(),
                                            reset: true
                                        });
                                        _getAssets1 = function() {
                                            if (platform === "ios") {
                                                return (0, _getAssets).getAssets({
                                                    entryFiles: absoluteEntryFiles,
                                                    config: config,
                                                    transformOptions: transformOptions,
                                                    dependencyGraph: dependencyGraph,
                                                    transformer: transformer
                                                });
                                            }
                                            return [];
                                        };
                                        _ctx.t0 = _slicedToArray;
                                        _ctx.next = 14;
                                        return Promise.all([
                                            (0, _getPrepended).getPrepended({
                                                config: config,
                                                transformOptions: transformOptions,
                                                dependencyGraph: dependencyGraph,
                                                platform: platform,
                                                transformer: transformer,
                                                extraVars: {
                                                    __HYEXT_RN_VER__: "".concat(process.env.HYEXT_RN_VER || "0.67.2"),
                                                    HYEXT_BUILD_ENV: "".concat(process.env.HYEXT_BUILD_ENV || "dev"),
                                                    HYEXT_BUILD_TYPE: "rn",
                                                    HYEXT_IMAGE_BASE_URL: config.imageBaseURL.endsWith("/") ? config.imageBaseURL.slice(0, config.imageBaseURL.length - 1) : config.imageBaseURL
                                                }
                                            }),
                                            _getAssets1(), 
                                        ]);
                                    case 14:
                                        _ctx.t1 = _ctx.sent;
                                        ref2 = (0, _ctx.t0)(_ctx.t1, 2);
                                        prepend = ref2[0];
                                        assets = ref2[1];
                                        return _ctx.abrupt("return", {
                                            graph: graph,
                                            prepend: prepend,
                                            deltaCalculator: deltaCalculator,
                                            platform: platform,
                                            assets: assets
                                        });
                                    case 19:
                                    case "end":
                                        return _ctx.stop();
                                }
                            }, _callee);
                        }));
                        return function getPlatformGraph(platform) {
                            return _ref.apply(this, arguments);
                        };
                    }();
                    graphList = [];
                    _ctx.t0 = graphList;
                    _ctx.next = 13;
                    return getPlatformGraph("ios");
                case 13:
                    _ctx.t1 = _ctx.sent;
                    _ctx.t0.push.call(_ctx.t0, _ctx.t1);
                    _ctx.t2 = graphList;
                    _ctx.next = 18;
                    return getPlatformGraph("android");
                case 18:
                    _ctx.t3 = _ctx.sent;
                    _ctx.t2.push.call(_ctx.t2, _ctx.t3);
                    promiseFactories = [];
                    bundleConfigs.forEach(function(xs) {
                        graphList.forEach(function(grph) {
                            promiseFactories.push(function() {
                                return (0, _saveOutput).default({
                                    entryAbsPath: xs.entryAbsPath,
                                    outputAbsPath: _path.default.join(xs.outputDir, "index.".concat(grph.platform, ".jsbundle")),
                                    dependencyGraph: dependencyGraph,
                                    graph: grph.graph,
                                    config: config,
                                    serializerOptions: serializerOptions,
                                    prepend: grph.prepend,
                                    platform: grph.platform
                                });
                            });
                        });
                    });
                    _ctx.next = 24;
                    return promiseFactories.reduce(function(queue, cur) {
                        // @ts-ignore
                        return queue.then(function(acc) {
                            return cur().then(function(result) {
                                return _toConsumableArray(acc).concat([
                                    result
                                ]);
                            });
                        });
                    }, Promise.resolve([]));
                case 24:
                    outputList = _ctx.sent;
                    assets = (ref = graphList.find(function(xs) {
                        return xs.platform === "ios";
                    })) === null || ref === void 0 ? void 0 : ref.assets;
                    _ctx.next = 28;
                    return (0, _saveAssets).default(assets, "ios", config.assetsDir);
                case 28:
                    graphList.forEach(function(param) {
                        var deltaCalculator = param.deltaCalculator;
                        return deltaCalculator.end();
                    });
                    transformer.end();
                    dependencyGraph.end();
                    return _ctx.abrupt("return", outputList);
                case 32:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return _batchCompile.apply(this, arguments);
}
