"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.calcTransformerOptions = void 0;
var _regeneratorRuntime = _interopRequireDefault(require("regenerator-runtime"));
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _objectSpreadProps(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
var calcTransformerOptions = function() {
    var _ref = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee(config, options) {
        var baseOptions, transform;
        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    baseOptions = {
                        customTransformOptions: options.customTransformOptions,
                        dev: options.dev,
                        hot: options.hot,
                        inlineRequires: false,
                        inlinePlatform: true,
                        minify: options.minify,
                        platform: options.platform,
                        runtimeBytecodeVersion: options.runtimeBytecodeVersion,
                        unstable_transformProfile: options.unstable_transformProfile
                    };
                    if (!(options.type === "script")) {
                        _ctx.next = 3;
                        break;
                    }
                    return _ctx.abrupt("return", _objectSpreadProps(_objectSpread({}, baseOptions), {
                        type: "script"
                    }));
                case 3:
                    _ctx.next = 5;
                    return config.transformer.getTransformOptions();
                case 5:
                    transform = _ctx.sent.transform;
                    return _ctx.abrupt("return", _objectSpreadProps(_objectSpread({}, baseOptions), {
                        inlineRequires: (transform === null || transform === void 0 ? void 0 : transform.inlineRequires) || false,
                        experimentalImportSupport: (transform === null || transform === void 0 ? void 0 : transform.experimentalImportSupport) || false,
                        unstable_disableES6Transforms: (transform === null || transform === void 0 ? void 0 : transform.unstable_disableES6Transforms) || false,
                        nonInlinedRequires: (transform === null || transform === void 0 ? void 0 : transform.nonInlinedRequires) || [
                            "React",
                            "react",
                            "react-native"
                        ],
                        type: "module"
                    }));
                case 7:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return function calcTransformerOptions(config, options) {
        return _ref.apply(this, arguments);
    };
}();
exports.calcTransformerOptions = calcTransformerOptions;
