"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getDependencies = getDependencies;
var _regeneratorRuntime = _interopRequireDefault(require("regenerator-runtime"));
var _deltaCalculator = _interopRequireDefault(require("metro/src/DeltaBundler/DeltaCalculator"));
var _calcTransformerOptions = require("./calcTransformerOptions");
var _getType = require("./getType");
var _getExtMetroConfig = require("../matrix-config/getExtMetroConfig");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _objectSpreadProps(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
function getDependencies(options) {
    return _getDependencies.apply(this, arguments);
}
function _getDependencies() {
    _getDependencies = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee(options) {
        var dependencyGraph, config, entryFiles, transformOptions, transformer, _otherOptions, otherOptions, calculatedOptions, deltaCalculator, graph;
        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    dependencyGraph = options.dependencyGraph, config = options.config, entryFiles = options.entryFiles, transformOptions = options.transformOptions, transformer = options.transformer, _otherOptions = options.otherOptions, otherOptions = _otherOptions === void 0 ? {
                        onProgress: null,
                        shallow: false
                    } : _otherOptions;
                    _ctx.next = 3;
                    return (0, _calcTransformerOptions).calcTransformerOptions(config, transformOptions);
                case 3:
                    calculatedOptions = _ctx.sent;
                    deltaCalculator = new _deltaCalculator.default(entryFiles, dependencyGraph, {
                        resolve: function(from, to) {
                            return dependencyGraph.resolveDependency(from, to, transformOptions.platform);
                        },
                        transform: function(filepath) {
                            if (!config.serializer.processModuleFilter({
                                path: filepath
                            })) {
                                return Promise.resolve(_getExtMetroConfig.skipModulePlaceHolder);
                            }
                            return transformer.transformFile(filepath, _objectSpreadProps(_objectSpread({}, calculatedOptions), {
                                type: (0, _getType).getType(config, calculatedOptions, filepath),
                                inlineRequires: false
                            }));
                        },
                        transformOptions: transformOptions,
                        onProgress: otherOptions.onProgress,
                        experimentalImportBundleSupport: config.transformer.experimentalImportBundleSupport,
                        shallow: otherOptions.shallow
                    });
                    _ctx.next = 7;
                    return deltaCalculator.getDelta({
                        reset: true,
                        shallow: otherOptions.shallow
                    });
                case 7:
                    graph = deltaCalculator.getGraph();
                    deltaCalculator.end();
                    return _ctx.abrupt("return", graph.dependencies);
                case 10:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return _getDependencies.apply(this, arguments);
}
