"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getPrepended = void 0;
var _regeneratorRuntime = _interopRequireDefault(require("regenerator-runtime"));
var _defaults = _interopRequireDefault(require("metro-config/src/defaults/defaults"));
var _getPreludeCode = _interopRequireDefault(require("metro/src/lib/getPreludeCode"));
var _countLines = _interopRequireDefault(require("metro/src/lib/countLines"));
var _metroHermesCompiler = require("metro-hermes-compiler");
var _getDependencies = require("./getDependencies");
function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _objectSpreadProps(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
var getPrepended = function() {
    var _ref = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee(options) {
        var config, transformOptions, dependencyGraph, platform, transformer, extraVars, polyfillModuleNames, dependencies, getPrelude;
        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    config = options.config, transformOptions = options.transformOptions, dependencyGraph = options.dependencyGraph, platform = options.platform, transformer = options.transformer, extraVars = options.extraVars;
                    polyfillModuleNames = config.serializer.getPolyfills({
                        platform: platform
                    }).concat(config.serializer.polyfillModuleNames);
                    _ctx.next = 4;
                    return (0, _getDependencies).getDependencies({
                        entryFiles: [
                            _defaults.default.moduleSystem
                        ].concat(_toConsumableArray(polyfillModuleNames)),
                        config: config,
                        dependencyGraph: dependencyGraph,
                        transformer: transformer,
                        transformOptions: _objectSpreadProps(_objectSpread({}, transformOptions), {
                            type: "script"
                        })
                    });
                case 4:
                    dependencies = _ctx.sent;
                    getPrelude = function() {
                        var code = (0, _getPreludeCode).default({
                            isDev: transformOptions.dev,
                            globalPrefix: config.transformer.globalPrefix,
                            extraVars: extraVars
                        });
                        var name = "__prelude__";
                        return {
                            dependencies: new Map(),
                            getSource: function() {
                                return Buffer.from(code);
                            },
                            inverseDependencies: new Set(),
                            path: name,
                            output: [
                                {
                                    type: "js/script/virtual",
                                    data: {
                                        code: code,
                                        lineCount: (0, _countLines).default(code),
                                        map: []
                                    }
                                },
                                {
                                    type: "bytecode/script/virtual",
                                    data: {
                                        bytecode: (0, _metroHermesCompiler).compile(code, {
                                            sourceURL: "__prelude__.virtual.js"
                                        }).bytecode
                                    }
                                }, 
                            ]
                        };
                    };
                    return _ctx.abrupt("return", [
                        getPrelude(), 
                    ].concat(_toConsumableArray(dependencies.values())));
                case 7:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return function getPrepended(options) {
        return _ref.apply(this, arguments);
    };
}();
exports.getPrepended = getPrepended;
