"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getSortedModules = void 0;
function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}
function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
var getSortedModules = function(graph, createModuleId) {
    var modules = _toConsumableArray(graph.dependencies.values());
    // 源码这里为什么要特意执行一次?
    // Assign IDs to modules in a consistent order
    // for (const module of modules) {
    //   this._createModuleId(module.path);
    // }
    // 其实 createModuleId 的签名是 string => number 的, 但小程序因历史原因,
    // 用的是 string => string, 所以内部的所有的排序都要注意
    return modules.sort(function(a, z) {
        var idA = createModuleId(a.path);
        var idZ = createModuleId(z.path);
        if (idA === idZ) return 0;
        if (idA > idZ) return 1;
        return -1;
    });
};
exports.getSortedModules = getSortedModules;
