"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = compile;
var _regeneratorRuntime = _interopRequireDefault(require("regenerator-runtime"));
var _logger = require("../lib/logger");
var _path = _interopRequireDefault(require("path"));
var _axios = _interopRequireDefault(require("axios"));
var _batchCompile = require("./batchCompile");
var _getExtMetroConfig = require("../matrix-config/getExtMetroConfig");
function compile(_) {
    return _compile.apply(this, arguments);
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _objectSpreadProps(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
function _compile() {
    _compile = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee(param) {
        var projectRoot, bundleConfigs, projectConfig, _extMetroConfig, extMetroConfig, allStart, config, result, cost, axiosConfig;
        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    projectRoot = param.projectRoot, bundleConfigs = param.bundleConfigs, projectConfig = param.projectConfig, _extMetroConfig = param.extMetroConfig, extMetroConfig = _extMetroConfig === void 0 ? {} : _extMetroConfig;
                    (0, _logger).dbg("compile start");
                    allStart = Date.now();
                    config = (0, _getExtMetroConfig).getExtMetroConfig({
                        projectRoot: projectRoot,
                        mode: "production",
                        projectConfig: projectConfig,
                        extMetroConfig: extMetroConfig
                    });
                    (0, _logger).dbg("config: %O", _objectSpreadProps(_objectSpread({}, config), {
                        reporter: undefined,
                        filterModules: undefined,
                        filterModulesVersion: undefined
                    }));
                    process.env.MATRIX_BABEL_PLUGINS = JSON.stringify((config === null || config === void 0 ? void 0 : config.babelPlugins) || []);
                    process.env.MATRIX_HYEXT_TRANSFORMER_CONFIG = JSON.stringify((config === null || config === void 0 ? void 0 : config.hyextTransformerConfig) || {});
                    _ctx.next = 9;
                    return (0, _batchCompile).batchCompile({
                        config: config,
                        bundleConfigs: bundleConfigs
                    });
                case 9:
                    result = _ctx.sent;
                    cost = Date.now() - allStart;
                    (0, _logger).dbg("totalCompileTime: %d", cost);
                    if (process.env.MATRIX_BUILD_ID) {
                        axiosConfig = {
                            method: "PUT",
                            url: "http://localhost:3002/telemetry/statExtra",
                            timeout: 3000,
                            data: {
                                buildId: process.env.MATRIX_BUILD_ID,
                                extra: [
                                    [
                                        bundleConfigs.map(function(xs) {
                                            return _path.default.basename(xs.outputDir);
                                        }).join(","),
                                        cost
                                    ]
                                ]
                            }
                        };
                        (0, _logger).dbg("axios Config: %s", JSON.stringify(axiosConfig));
                        (0, _axios).default(axiosConfig).catch(function(err) {
                            return console.error("ignore telemetry error: ".concat(err.message));
                        });
                    }
                    return _ctx.abrupt("return", result);
                case 14:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return _compile.apply(this, arguments);
}
