"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _regeneratorRuntime = _interopRequireDefault(require("regenerator-runtime"));
var _baseJSBundle = _interopRequireDefault(require("metro/src/DeltaBundler/Serializers/baseJSBundle"));
var _sourceMapString = _interopRequireDefault(require("metro/src/DeltaBundler/Serializers/sourceMapString"));
var _path = _interopRequireDefault(require("path"));
var _bunldeToString = require("./bunldeToString");
var _getSortedModules = require("./getSortedModules");
var _fsExtra = _interopRequireDefault(require("fs-extra"));
var _md5 = _interopRequireDefault(require("../lib/md5"));
function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
var saveOutput = function() {
    var _ref = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee(outputOptions) {
        var entryAbsPath, outputAbsPath, dependencyGraph, graph, config, serializerOptions, prepend, platform, bundleOptions, bundleCode, bundleMap;
        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    entryAbsPath = outputOptions.entryAbsPath, outputAbsPath = outputOptions.outputAbsPath, dependencyGraph = outputOptions.dependencyGraph, graph = outputOptions.graph, config = outputOptions.config, serializerOptions = outputOptions.serializerOptions, prepend = outputOptions.prepend, platform = outputOptions.platform;
                    bundleOptions = {
                        asyncRequireModulePath: dependencyGraph.resolveDependency("".concat(config.projectRoot, "/."), config.transformer.asyncRequireModulePath),
                        processModuleFilter: config.serializer.processModuleFilter,
                        createModuleId: config.serializer.createModuleIdFactory(),
                        getRunModuleStatement: config.serializer.getRunModuleStatement,
                        dev: false,
                        projectRoot: config.projectRoot,
                        modulesOnly: serializerOptions.modulesOnly,
                        runBeforeMainModule: config.serializer.getModulesRunBeforeMainModule(_path.default.relative(config.projectRoot, entryAbsPath)),
                        runModule: serializerOptions.runModule,
                        sourceMapUrl: serializerOptions.sourceMapUrl || "".concat(_path.default.basename(outputAbsPath), ".map"),
                        sourceUrl: serializerOptions.sourceUrl,
                        inlineSourceMap: serializerOptions.inlineSourceMap,
                        serverRoot: config.projectRoot
                    };
                    bundleCode = (0, _bunldeToString).bundleToString((0, _baseJSBundle).default(entryAbsPath, prepend, graph, bundleOptions)).code;
                    bundleMap = (0, _sourceMapString).default(_toConsumableArray(prepend).concat(_toConsumableArray((0, _getSortedModules).getSortedModules(graph, config.serializer.createModuleIdFactory()))), {
                        excludeSource: serializerOptions.excludeSource,
                        processModuleFilter: config.serializer.processModuleFilter
                    });
                    _ctx.next = 6;
                    return _fsExtra.default.ensureDir(_path.default.dirname(outputAbsPath));
                case 6:
                    _ctx.next = 8;
                    return Promise.all([
                        _fsExtra.default.writeFile(outputAbsPath, bundleCode, {
                            encoding: "utf8"
                        }),
                        _fsExtra.default.writeFile("".concat(outputAbsPath, ".map"), bundleMap), 
                    ]);
                case 8:
                    _ctx.t0 = entryAbsPath;
                    _ctx.t1 = outputAbsPath;
                    _ctx.next = 12;
                    return (0, _md5).default(outputAbsPath);
                case 12:
                    _ctx.t2 = _ctx.sent;
                    _ctx.t3 = platform;
                    return _ctx.abrupt("return", {
                        entryAbsPath: _ctx.t0,
                        bundleAbsPath: _ctx.t1,
                        bundleMd5: _ctx.t2,
                        platform: _ctx.t3
                    });
                case 15:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return function saveOutput(outputOptions) {
        return _ref.apply(this, arguments);
    };
}();
var _default = saveOutput;
exports.default = _default;
