"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = blacklist;
var _path = _interopRequireDefault(require("path"));
function blacklist(additionalBlacklist) {
    // Don't forget to everything listed here to `package.json`
    // modulePathIgnorePatterns.
    var sharedBlacklist = [
        /node_modules\/react\/dist\/.*/,
        /website\/node_modules\/.*/,
        /heapCapture\/bundle\.js/,
        /.*\/__tests__\/.*/, 
    ];
    var escapeRegExp = function(pattern) {
        if (Object.prototype.toString.call(pattern) === "[object RegExp]") {
            // @ts-ignore
            return pattern.source.replace(/\//g, _path.default.sep);
        } else if (typeof pattern === "string") {
            var escaped = pattern.replace(/[\-\[\]\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
            // convert the '/' into an escaped local file separator
            return escaped.replace(/\//g, "\\" + _path.default.sep);
        } else {
            throw new Error("Unexpected blacklist pattern: " + pattern);
        }
    };
    return new RegExp("(" + (additionalBlacklist || []).concat(sharedBlacklist).map(escapeRegExp).join("|") + ")$");
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
