"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getExtMetroConfig = getExtMetroConfig;
exports.skipModulePlaceHolder = void 0;
var _regeneratorRuntime = _interopRequireDefault(require("regenerator-runtime"));
var _path = _interopRequireDefault(require("path"));
var _metroCache = require("metro-cache");
var _metroConfig = require("metro-config");
var _defaults = require("metro-config/src/defaults");
var _cliPluginMetro = require("@react-native-community/cli-plugin-metro");
var _createModuleIdHOF = require("./createModuleIdHOF");
var _resolveReactNativePath = _interopRequireDefault(require("./resolveReactNativePath"));
var _filterModuleHOF = _interopRequireDefault(require("./filterModuleHOF"));
var _ramda = require("ramda");
function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
var skipModulePlaceHolder = {
    dependencies: [],
    output: [],
    getSource: function() {
        return Buffer.from("");
    }
};
exports.skipModulePlaceHolder = skipModulePlaceHolder;
function getExtMetroConfig(options) {
    var _extraWatchFolder;
    var projectRoot = options.projectRoot, mode = options.mode, projectConfig = options.projectConfig, _extMetroConfig = options.extMetroConfig, _filterModules = _extMetroConfig.filterModules, filterModules = _filterModules === void 0 ? new Set() : _filterModules, _filterModulesVersion = _extMetroConfig.filterModulesVersion, filterModulesVersion = _filterModulesVersion === void 0 ? new Set() : _filterModulesVersion, _SDKAlias = _extMetroConfig.SDKAlias, SDKAlias = _SDKAlias === void 0 ? {} : _SDKAlias, _extraPolyfills = _extMetroConfig.extraPolyfills, extraPolyfills = _extraPolyfills === void 0 ? [] : _extraPolyfills, _extraModulesRunFirst = _extMetroConfig.extraModulesRunFirst, extraModulesRunFirst = _extraModulesRunFirst === void 0 ? [] : _extraModulesRunFirst;
    // metro 默认值: metro-config/src/defaults/index.js
    var officialDefaultConfig = (0, _defaults).getDefaultValues(projectRoot);
    var officialCliConfig = (0, _cliPluginMetro).getDefaultConfig({
        platforms: {},
        reactNativePath: (0, _resolveReactNativePath).default([
            process.env.MATRIX_SHARE_PROJECT_RN_ROOT,
            projectRoot
        ].filter(Boolean))
    });
    var officialConfig = (0, _metroConfig).mergeConfig(officialDefaultConfig, officialCliConfig);
    // 所以的依赖必须要归到 watchFolder 中去, 否则找不到相关的文件, 或者文件缺失md5
    var extraWatchFolder = [
        "metro-runtime/src/modules/asyncRequire",
        "@react-native-community/cli-plugin-metro"
    ].map(function(xs) {
        return require.resolve(xs);
    }).map(function(xs) {
        return require.resolve("metro-runtime/src/modules/asyncRequire", {
            paths: [
                xs
            ]
        });
    }) // watch asyncRequire 所在的文件夹
    .map(function(xs) {
        return _path.default.dirname(xs);
    });
    // watch matrix-config 所在的文件夹
    extraWatchFolder.push(_path.default.resolve(__dirname));
    // watch metro-runtime/src 文件夹
    extraWatchFolder.push(_path.default.join(_path.default.dirname(require.resolve("metro-runtime/package.json")), "src"));
    (_extraWatchFolder = extraWatchFolder).push.apply(_extraWatchFolder, _toConsumableArray(extraModulesRunFirst.map(function(xs) {
        return _path.default.dirname(xs);
    })).concat(_toConsumableArray(extraPolyfills.map(function(xs) {
        return _path.default.dirname(xs);
    }))));
    /*
   * 开发环境下, 这个值设置为true, 否则会遇到问题:
   * https://github.com/facebook/react-native/issues/28801
   */ var inlineRequires = true;
    var watchFolders = (0, _ramda).uniq([
        projectRoot
    ].concat(_toConsumableArray(extraWatchFolder)));
    var nodeModulesPaths = [
        _path.default.join(projectRoot, "node_modules")
    ];
    var assetRegistryPath = officialConfig.transformer.assetRegistryPath;
    var useWatchman = true;
    var createModuleIdFactory = _createModuleIdHOF.defaultFactory;
    if (mode !== "dev") {
        inlineRequires = false;
        assetRegistryPath = _path.default.resolve(_path.default.join(__dirname, "assetRegistry.js"));
        useWatchman = false;
        createModuleIdFactory = (0, _createModuleIdHOF).createModuleIdHOF({
            projectRoot: projectRoot,
            SDKAlias: SDKAlias,
            filterModules: filterModules
        });
        if (process.env.MATRIX_SHARE_PROJECT_RN_ROOT) {
            var shareModules = _path.default.join(process.env.MATRIX_SHARE_PROJECT_RN_ROOT, "node_modules");
            // 大部分包(react/react-dom/react-native/sdk)其实都在 projectRoot/node_modules 这一层,
            // 所以先搜索这个位置比较高效
            nodeModulesPaths = [
                shareModules
            ].concat(_toConsumableArray(nodeModulesPaths));
            watchFolders.push(shareModules);
        }
    }
    var CACHE_PATH = _path.default.join(process.env.MATRIX_CACHE_ROOT || _path.default.join(projectRoot, "node_modules", ".huya-ext-cache"), "metro");
    var hyextConfig = {
        resolver: {
            sourceExts: _toConsumableArray(officialConfig.resolver.sourceExts).concat([
                "jsx",
                "hycss"
            ]),
            platforms: [
                "ios",
                "android",
                "native",
                "web"
            ],
            nodeModulesPaths: nodeModulesPaths,
            blockList: _toConsumableArray(Array.isArray(officialConfig.resolver.blockList) ? officialConfig.resolver.blockList : [
                officialConfig.resolver.blockList
            ]).concat(_toConsumableArray(options.extMetroConfig.blockRegexp || [])),
            useWatchman: useWatchman
        },
        serializer: {
            processModuleFilter: (0, _filterModuleHOF).default({
                projectRoot: projectRoot,
                SDKAlias: SDKAlias,
                filterModules: filterModules,
                filterModulesVersion: filterModulesVersion,
                mode: mode
            }),
            createModuleIdFactory: createModuleIdFactory,
            getModulesRunBeforeMainModule: function(entryRelative) {
                var officialRunBefore = officialConfig.serializer.getModulesRunBeforeMainModule(entryRelative);
                return _toConsumableArray(officialRunBefore).concat(_toConsumableArray(extraModulesRunFirst));
            },
            getPolyfills: function(opts) {
                var officialPolyfills = officialConfig.serializer.getPolyfills(opts);
                return _toConsumableArray(officialPolyfills).concat(_toConsumableArray(extraPolyfills));
            }
        },
        server: {
            port: options.port || 8081,
            // 中间件的执行顺序: communityCLI => metroMiddleware.
            // 这个中间件中的逻辑, 会晚于 communityCLI 的中间件执行
            enhanceMiddleware: undefined
        },
        transformer: {
            // babelPlugins: [],
            enableBabelRCLookup: false,
            getTransformOptions: _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee() {
                return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
                    while(1)switch(_ctx.prev = _ctx.next){
                        case 0:
                            return _ctx.abrupt("return", {
                                transform: {
                                    experimentalImportSupport: false,
                                    inlineRequires: inlineRequires,
                                    unstable_disableES6Transforms: false
                                },
                                preloadedModules: false,
                                ramGroups: []
                            });
                        case 1:
                        case "end":
                            return _ctx.stop();
                    }
                }, _callee);
            })),
            // asyncRequireModulePath: require.resolve('metro-runtime/src/modules/asyncRequire'),
            babelTransformerPath: _path.default.join(__dirname, "../matrix-config/babelTransformer.js"),
            assetRegistryPath: assetRegistryPath,
            // publicPath用来决定图片的地址, 开发环境需设置为空
            publicPath: "/"
        },
        cacheStores: [
            new _metroCache.FileStore({
                root: CACHE_PATH
            })
        ],
        hasteMapCacheDirectory: CACHE_PATH,
        // 确保不同的小程序能产生不同的缓存值
        cacheVersion: (projectConfig === null || projectConfig === void 0 ? void 0 : projectConfig.cacheVersion) || "1",
        projectRoot: projectRoot,
        watchFolders: watchFolders,
        onReady: function() {},
        enableRootBabelRC: false
    };
    return (0, _metroConfig).mergeConfig(officialDefaultConfig, officialCliConfig, hyextConfig, options.extMetroConfig);
}
